local function update()
    
    if game == "star-road" then

        --Chuckya Harbor
        if gGlobalSyncTable.level == 4 then
            if obj_get_first_with_behavior_id(id_bhvPushableMetalBox) ~= nil then
            obj_set_dormant(obj_get_first_with_behavior_id(id_bhvPushableMetalBox), true)
            end
        end

        --Gloomy Garden
        if gGlobalSyncTable.level == 5 then
            for_each_object_with_behavior(bhvSMSRRedWavePlatform, function(obj)
                obj_set_dormant(obj, (obj.oFaceAnglePitch & 0xFFFF) ~= 0)
            end)
        end

        --Colorful Coral Caverns
        if gGlobalSyncTable.level == 6 then
            for_each_object_with_behavior(bhvSMSRBreakableFloor, function(obj)
                obj_set_dormant(obj, obj.oPosZ == 3275)
            end)
        end

        --Koopa Canyon
        if gGlobalSyncTable.level == 7 then
            for_each_object_with_behavior(id_bhvPushableMetalBox, function(obj)
                obj_set_dormant(obj, (obj.oFaceAngleRoll & 0xFFFF) ~= 0)
            end)
        end

        -- Forest
        if gGlobalSyncTable.level == 8 then
            omm_world_behavior_set_dormant_params(bhvSMSRMipsMessage, 0x008B0000, true)
        end
        
    end

end

hook_event(HOOK_UPDATE, update)