--LEVEL_ID, COURSE_ID, STAR_COUNT
levels = {

    {LEVEL_BOB, 1, 7}, --1
    {LEVEL_WF, 2, 7}, --2
    {LEVEL_JRB, 3, 7}, --3
    {LEVEL_CCM, 4, 7}, --4
    {LEVEL_BBH, 5, 7}, --5
    {LEVEL_HMC, 6, 7}, --6
    {LEVEL_LLL, 7, 7}, --7
    {LEVEL_SSL, 8, 7}, --8
    {LEVEL_DDD, 9, 7}, --9
    {LEVEL_SL, 10, 7}, --10
    {LEVEL_WDW, 11, 7}, --11
    {LEVEL_TTM, 12, 7}, --12
    {LEVEL_THI, 13, 7}, --13
    {LEVEL_TTC, 14, 7}, --14
    {LEVEL_RR, 15, 7}, --15

    {LEVEL_BITDW, 16, 1}, --16
    {LEVEL_BITFS, 17, 1}, --17
    {LEVEL_BITS, 18, 1}, --18
    
    {LEVEL_TOTWC, 21, 1}, --19
    {LEVEL_VCUTM, 22, 1}, --20
    {LEVEL_COTMC, 20, 1}, --21
    
    {LEVEL_PSS, 19, 2}, --22
    {LEVEL_SA, 24, 1}, --23
    {LEVEL_WMOTR, 23, 1}, --24

}

waitingRoom = LEVEL_CASTLE_COURTYARD
fullGameSeq = {
    1, 2, 3, 4, 5, 
    22, 23, 19, 16,
    6, 7, 8, 9,
    20, 21, 17,
    10, 11, 12, 13, 14, 15,
    24, 18 
}

-- Detect Game
game = "sm64"
for mod in pairs(gActiveMods) do
    if gActiveMods[mod].incompatible ~= nil and gActiveMods[mod].incompatible:find("romhack") then
        game = gActiveMods[mod].relativePath
    end
end

if game == "star-road" then
    levels[19] = {LEVEL_COTMC, 20, 1}
    levels[21] = {LEVEL_TOTWC, 21, 1}
    levels[23][3] = 2
    waitingRoom = LEVEL_CASTLE
    fullGameSeq = {
        1, 2, 3, 4, 5, 
        22, 19, 20, 16,
        6, 7, 8, 9, 10,
        23, 17,
        11, 12, 13, 14, 15,
        21, 18, 24
    }
end

if game == "sm74" then
    levels[19] = {LEVEL_COTMC, 20, 1}
    levels[20] = {LEVEL_TOTWC, 21, 1}
    levels[21] = {LEVEL_VCUTM, 22, 1}
    table.remove(levels, 24)
    levels[16][3] = 4
    levels[17][3] = 5
    levels[18][3] = 6
    levels[19][3] = 5
    levels[20][3] = 3
    levels[21][3] = 6
    levels[22][3] = 4
    waitingRoom = LEVEL_CASTLE
    fullGameSeq = {
        1, 2, 3, 
        19, 16,
        4, 5, 6, 7, 8, 9,
        22, 20, 21, 17,
        10, 11, 12, 13, 14, 15,
        23, 18 
    }
end

if game == "rainbow-road" then
    levels = {
        {LEVEL_BOB, 1, 7}, --1
        {LEVEL_WF, 2, 7}, --2
        {LEVEL_JRB, 3, 7}, --3
        {LEVEL_CCM, 4, 7}, --4
        {LEVEL_BBH, 5, 7}, --5
        {LEVEL_HMC, 6, 7}, --6
        {LEVEL_LLL, 7, 7}, --7

        {LEVEL_BITDW, 16, 1}, --8
    
        {LEVEL_TOTWC, 21, 1}, --9
        {LEVEL_VCUTM, 22, 1}, --10
        {LEVEL_COTMC, 20, 1}, --11

        {LEVEL_SA, 24, 1}, --12
    }
    waitingRoom = LEVEL_CASTLE_COURTYARD
    fullGameSeq = {1, 2, 3, 4, 5, 9, 10, 11, 8, 6, 7, 12}
end

if game == "sapphire" then
    levels = {
        {LEVEL_BOB, 1, 7},
        {LEVEL_WF, 2, 7},
        {LEVEL_JRB, 3, 7},
        {LEVEL_CCM, 4, 7},
        {LEVEL_PSS, 19, 2}
    }
    waitingRoom = LEVEL_BITS
    fullGameSeq = {1, 2, 3, 4, 5}
end