function packet_receive(data)

    if data.packet == "message" then
        djui_chat_message_create("\\#80FF80\\" .. data.message)
    end

    if data.packet == "reset" then
        for i = COURSE_NONE - 1, COURSE_MAX - 1, 1 do
            save_file_remove_star_flags(get_current_save_file_num() - 1, i, 255)
        end
        
        save_file_clear_flags(SAVE_FLAG_COLLECTED_MIPS_STAR_1)
        save_file_clear_flags(SAVE_FLAG_COLLECTED_MIPS_STAR_2)
        save_file_clear_flags(SAVE_FLAG_COLLECTED_TOAD_STAR_1)
        save_file_clear_flags(SAVE_FLAG_COLLECTED_TOAD_STAR_2)
        save_file_clear_flags(SAVE_FLAG_COLLECTED_TOAD_STAR_3)
        save_file_set_flags(SAVE_FLAG_HAVE_METAL_CAP)
        save_file_set_flags(SAVE_FLAG_HAVE_VANISH_CAP)
        save_file_set_flags(SAVE_FLAG_HAVE_WING_CAP)
        save_file_set_flags(SAVE_FLAG_UNLOCKED_50_STAR_DOOR)
        save_file_set_flags(SAVE_FLAG_UNLOCKED_BASEMENT_DOOR)
        save_file_set_flags(SAVE_FLAG_UNLOCKED_BITDW_DOOR)
        save_file_set_flags(SAVE_FLAG_UNLOCKED_BITFS_DOOR)
        save_file_set_flags(SAVE_FLAG_UNLOCKED_CCM_DOOR)
        save_file_set_flags(SAVE_FLAG_UNLOCKED_JRB_DOOR)
        save_file_set_flags(SAVE_FLAG_UNLOCKED_PSS_DOOR)
        save_file_set_flags(SAVE_FLAG_UNLOCKED_UPSTAIRS_DOOR)
        save_file_set_flags(SAVE_FLAG_UNLOCKED_WF_DOOR)
        gMarioStates[0].numStars = save_file_get_total_star_count(get_current_save_file_num() - 1, COURSE_NONE, COURSE_MAX - 1)
        gMarioStates[0].health = 0x880
    
        save_file_do_save(get_current_save_file_num() - 1, true)
    end

    if data.packet == "sync" then
        if not network_is_server() then
            gGlobalSyncTable.level = data.level
            gGlobalSyncTable.timer = data.timer
            gGlobalSyncTable.transform = data.transform
            gGlobalSyncTable.reload = data.reload
            gGlobalSyncTable.levelIndex = data.levelIndex
        end
    end

end

hook_event(HOOK_ON_PACKET_RECEIVE, packet_receive)