gPlayerSyncTable[0].racingpenguinreset = false

function racingpenguinhome_init()

end

function racingpenguinhome_loop()

end

--- @param o Object
--- what happens when failing the race
local function racingpenguinracerestart(o)
    local racingpenguinhome = obj_get_nearest_object_with_behavior_id(gMarioStates[0].marioObj,id_bhvracingpenguinhome)
    if (o == nil) or (racingpenguinhome == nil) then
        return
    end
    o.oPosX = racingpenguinhome.oHomeX
    o.oPosY = racingpenguinhome.oHomeY
    o.oPosZ = racingpenguinhome.oHomeZ
    o.oSubAction = racingpenguinhome.oSubAction
    o.oAction = racingpenguinhome.oAction
    o.areaTimer = racingpenguinhome.areaTimer
    o.areaTimerDuration = racingpenguinhome.areaTimerDuration
    o.oRacingPenguinReachedBottom = racingpenguinhome.oRacingPenguinReachedBottom
    o.oRacingPenguinWeightedNewTargetSpeed = racingpenguinhome.oRacingPenguinWeightedNewTargetSpeed
    o.oRacingPenguinMarioWon = racingpenguinhome.oRacingPenguinMarioWon
    o.oRacingPenguinFinalTextbox = racingpenguinhome.oRacingPenguinFinalTextbox
    o.oRacingPenguinMarioCheated = racingpenguinhome.oRacingPenguinMarioCheated
    o.oPathedPrevWaypointFlags = racingpenguinhome.oPathedPrevWaypointFlags
    o.oPathedTargetPitch = racingpenguinhome.oPathedTargetPitch
    o.oPathedTargetYaw = racingpenguinhome.oPathedTargetYaw
    network_send_object(o, true)
end

---@param dialogId integer
--Called when a dialog appears. Return false to prevent it from appearing. Return a second parameter as any string to override the text in the textbox
local function on_dialog(dialogId)
    local m = gMarioStates[0]
    if (dialogId == gBehaviorValues.dialogs.RacingPenguinCheatDialog) or (dialogId == gBehaviorValues.dialogs.RacingPenguinLostDialog) then --when mario loses to the racing penguin
        local racingpenguin = obj_get_nearest_object_with_behavior_id(m.marioObj,id_bhvRacingPenguin)
        if (racingpenguin ~= nil) then
            for i = 0,MAX_PLAYERS - 1,1 do
                if gNetworkPlayers[i].currLevelNum == gNetworkPlayers[0].currLevelNum and gNetworkPlayers[i].currActNum == gNetworkPlayers[0].currActNum then
                    gPlayerSyncTable[i].racingpenguinreset = true
                end
            end
            
            return false
        end
    elseif (dialogId == gBehaviorValues.dialogs.RacingPenguinStartDialog) or (dialogId == gBehaviorValues.dialogs.RacingPenguinBigStartDialog) then --mario talking to the penguin before the race
        if obj_get_nearest_object_with_behavior_id(gMarioStates[0].marioObj,id_bhvracingpenguinhome) == nil then
            local racingpenguin = obj_get_nearest_object_with_behavior_id(m.marioObj,id_bhvRacingPenguin)
            
            if racingpenguin == nil then
                spawn_sync_object(id_bhvracingpenguinhome, E_MODEL_NONE, m.marioObj.oPosX, m.marioObj.oPosY,m.marioObj.oPosZ,nil)
            else
               
                spawn_sync_object(id_bhvracingpenguinhome, E_MODEL_NONE, racingpenguin.oPosX, racingpenguin.oPosY,racingpenguin.oPosZ,function (obj)
                    obj.oAction = 0
                    obj.oSubAction = racingpenguin.oSubAction
                    obj.oFaceAnglePitch = racingpenguin.oFaceAnglePitch
                    obj.oFaceAngleYaw = racingpenguin.oFaceAngleYaw
                    obj.areaTimer = racingpenguin.areaTimer
                    obj.areaTimerDuration = racingpenguin.areaTimerDuration
                    obj.oRacingPenguinReachedBottom = racingpenguin.oRacingPenguinReachedBottom
                    obj.oRacingPenguinWeightedNewTargetSpeed = racingpenguin.oRacingPenguinWeightedNewTargetSpeed
                    obj.oRacingPenguinMarioWon = racingpenguin.oRacingPenguinMarioWon
                    obj.oRacingPenguinFinalTextbox = racingpenguin.oRacingPenguinFinalTextbox
                    obj.oRacingPenguinMarioCheated = racingpenguin.oRacingPenguinMarioCheated
                    obj.oPathedPrevWaypointFlags = racingpenguin.oPathedPrevWaypointFlags
                    obj.oPathedTargetPitch = racingpenguin.oPathedTargetPitch
                    obj.oPathedTargetYaw = racingpenguin.oPathedTargetYaw
                end)
                
            end
        end
    end
end

-- hook that is called once per frame
local function hook_update()
    local m = gMarioStates[0]
    if (gPlayerSyncTable[0].racingpenguinreset) then
        local racingpenguin = obj_get_nearest_object_with_behavior_id(m.marioObj,id_bhvRacingPenguin)
        racingpenguinracerestart(racingpenguin)
        gPlayerSyncTable[0].racingpenguinreset = false
    end
end

-- Called when the level is initialized
local function on_level_init()
    gPlayerSyncTable[0].racingpenguinreset = false
end

hook_event(HOOK_ON_DIALOG,on_dialog)--Called when a dialog appears. Return false to prevent it from appearing. Return a second parameter as any string to override the text in the textbox
hook_event(HOOK_UPDATE,hook_update) -- hook that is called once per frame	
hook_event(HOOK_ON_LEVEL_INIT, on_level_init) -- Called when the level is initialized

id_bhvracingpenguinhome = hook_behavior(nil, OBJ_LIST_LEVEL, true, racingpenguinhome_init, racingpenguinhome_loop) --behavior id of the racingpenguin home
