local wdwCount = 0

local function update()

    if game == "sm64" then

        --Bob-Omb Battlefield
        if gGlobalSyncTable.level == 1 then
            omm_world_behavior_set_dormant(id_bhvTtmBowlingBallSpawner, true)
            omm_world_behavior_set_dormant(id_bhvWaterBombCannon, true)
            omm_world_behavior_set_dormant(id_bhvCannonBarrelBubbles, true)
            omm_world_behavior_set_dormant_params(id_bhvBobombBuddy, 0x00020000, true)
            omm_world_behavior_set_dormant_params(id_bhvBobombBuddy, 0x00030000, true)
        end

        --Whomp's Fortress
        if gGlobalSyncTable.level == 2 then
            
            omm_world_behavior_set_dormant(id_bhvKickableBoard, not gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhv1Up, not gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvBulletBill, not gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvTower, not gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvBulletBillCannon, not gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvTowerPlatformGroup, not gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvTowerDoor, not gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvWfSolidTowerPlatform, not gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvWfSlidingTowerPlatform, not gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvWfElevatorTowerPlatform, not gGlobalSyncTable.transform)
           
            if network_is_server() and save_file_get_star_flags(get_current_save_file_num() - 1, COURSE_WF-1) & (1 << 0) ~= 0 then
                gGlobalSyncTable.transform = true
            end
            
            vec3f_set(gLevelValues.starPositions.KingWhompStarPos, -600.0, 3800.0, 1000.0)
            omm_world_behavior_set_dormant_params(id_bhvStar, 0x01000000, not gGlobalSyncTable.transform)
        end

        --Jolly Roger Bay
        if gGlobalSyncTable.level == 3 then
            
            omm_world_behavior_set_dormant_params(id_bhvUnagi, 0x00000000, true)
            omm_world_behavior_set_dormant_params(id_bhvUnagi, 0x02020000, false)
            omm_world_behavior_set_dormant(id_bhvInSunkenShip, gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvSunkenShipPart, gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvSunkenShipPart2, gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvInSunkenShip, gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvInSunkenShip2, gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvShipPart3, not gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvInSunkenShip3, not gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvJrbSlidingBox, not gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant(id_bhvJetStream, not gGlobalSyncTable.transform)
            omm_world_behavior_set_dormant_params(id_bhvStar, 0x05000000, not gGlobalSyncTable.transform)
            
            local jetstream = obj_get_first_with_behavior_id(id_bhvJetStream)
            if jetstream ~= nil and not (jetstream.activeFlags & ACTIVE_FLAG_DORMANT) ~= 0 and gGlobalSyncTable.transform then
                set_whirlpools(jetstream.oPosX, jetstream.oPosY, jetstream.oPosZ, -30, 1, 0)
            end

            if network_is_server() and save_file_get_star_flags(get_current_save_file_num() - 1, COURSE_JRB-1) & (1 << 0) ~= 0 then
                gGlobalSyncTable.transform = true
            end

            if gNetworkPlayers[0].currAreaIndex == 2 and gGlobalSyncTable.transform then
                warp_to_level(levels[gGlobalSyncTable.level][1], 1, 0)
            end

        end

        --Big Boo's Haunt
        if gGlobalSyncTable.level == 5 then
            omm_world_behavior_set_dormant(id_bhvHiddenStaircaseStep, true)
            omm_world_behavior_set_dormant(id_bhvBoo, true)
        end

        --Wet Dry World
        if gGlobalSyncTable.level == 11 then
            if wdwCount < 30 then
                set_environment_region(1, 80)
                wdwCount = wdwCount + 1
            end
        else
            wdwCount = 0
        end

        --Tick Tock Clock
        if gGlobalSyncTable.level == 14 then
            set_ttc_speed_setting(TTC_SPEED_STOPPED)
        end
        
    end

end

hook_event(HOOK_UPDATE, update)