gPlayerSyncTable[0].koopareset = false

function koopahome_init()

end

function koopahome_loop()

end

--- @param o Object
--- what happens when failing the race
local function kooparacerestart(o)
    local koopahome = obj_get_nearest_object_with_behavior_id(gMarioStates[0].marioObj,id_bhvkoopahome)
    if (o == nil) or (koopahome == nil) then
        return
    end
    o.oPosX = koopahome.oHomeX
    o.oPosY = koopahome.oHomeY
    o.oPosZ = koopahome.oHomeZ
    o.oSubAction = koopahome.oSubAction
    o.oAction = koopahome.oAction
    o.areaTimer = koopahome.areaTimer
    o.areaTimerDuration = koopahome.areaTimerDuration
    o.parentObj.oKoopaRaceEndpointRaceStatus = koopahome.parentObj.oKoopaRaceEndpointRaceStatus
    o.parentObj.oKoopaRaceEndpointRaceBegun = koopahome.parentObj.oKoopaRaceEndpointRaceBegun
    o.parentObj.oKoopaRaceEndpointRaceEnded = koopahome.parentObj.oKoopaRaceEndpointRaceEnded
    o.parentObj.oKoopaRaceEndpointKoopaFinished = koopahome.parentObj.oKoopaRaceEndpointKoopaFinished
    o.parentObj.oKoopaRaceEndpointUnk100 = koopahome.parentObj.oKoopaRaceEndpointUnk100
    network_send_object(o, true)
    network_send_object(o.parentObj, true)
end

---@param dialogId integer
--Called when a dialog appears. Return false to prevent it from appearing. Return a second parameter as any string to override the text in the textbox
local function on_dialog(dialogId)
    local m = gMarioStates[0]
    if (dialogId == gBehaviorValues.dialogs.KoopaQuickCheatedDialog) or (dialogId == gBehaviorValues.dialogs.KoopaQuickLostDialog) then --when mario loses to koopa the quick
        local koopa = obj_get_nearest_object_with_behavior_id(m.marioObj,id_bhvKoopa)
        if (koopa ~= nil) and (koopa.oKoopaMovementType < KOOPA_BP_KOOPA_THE_QUICK_BASE) then ---if obj_get_nearest_object_with_behavior_id got the wrong koopa
            while (koopa ~= nil) and (koopa.oKoopaMovementType < KOOPA_BP_KOOPA_THE_QUICK_BASE) do
                koopa = obj_get_next_with_same_behavior_id(koopa)
            end
        end
        if (koopa ~= nil) and (koopa.parentObj ~= nil) then
            for i = 0,MAX_PLAYERS - 1,1 do
                if gNetworkPlayers[i].currLevelNum == gNetworkPlayers[0].currLevelNum and gNetworkPlayers[i].currActNum == gNetworkPlayers[0].currActNum then
                    gPlayerSyncTable[i].koopareset = true
                end
            end
            
            return false
        end
    elseif (dialogId == gBehaviorValues.dialogs.KoopaQuickThiStartDialog) or (dialogId == gBehaviorValues.dialogs.KoopaQuickBobStartDialog) then --mario talking to koopa the quick before the race
        if obj_get_nearest_object_with_behavior_id(gMarioStates[0].marioObj,id_bhvkoopahome) == nil then
            local koopa = obj_get_nearest_object_with_behavior_id(gMarioStates[0].marioObj,id_bhvKoopa)
            if (koopa ~= nil) and (koopa.oKoopaMovementType < KOOPA_BP_KOOPA_THE_QUICK_BASE) then ---if obj_get_nearest_object_with_behavior_id got the wrong koopa
                while (koopa ~= nil) and (koopa.oKoopaMovementType < KOOPA_BP_KOOPA_THE_QUICK_BASE) do
                    koopa = obj_get_next_with_same_behavior_id(koopa)
                end
            end
            if koopa == nil then
                spawn_sync_object(id_bhvkoopahome, E_MODEL_NONE, m.marioObj.oPosX, m.marioObj.oPosY,m.marioObj.oPosZ,nil)
            else
               local koopahomeparent = spawn_sync_object(id_bhvkoopahomeparent, E_MODEL_NONE, koopa.parentObj.oPosX, koopa.parentObj.oPosY,koopa.parentObj.oPosZ,function (obj)
                    
                    obj.oKoopaRaceEndpointRaceStatus = koopa.parentObj.oKoopaRaceEndpointRaceStatus
                    obj.oKoopaRaceEndpointRaceBegun = koopa.parentObj.oKoopaRaceEndpointRaceBegun
                    obj.oKoopaRaceEndpointRaceEnded = koopa.parentObj.oKoopaRaceEndpointRaceEnded
                    obj.oKoopaRaceEndpointUnk100 = koopa.parentObj.oKoopaRaceEndpointUnk100
                    obj.oKoopaRaceEndpointKoopaFinished = koopa.parentObj.oKoopaRaceEndpointKoopaFinished
                end)
                spawn_sync_object(id_bhvkoopahome, E_MODEL_NONE, koopa.oPosX, koopa.oPosY,koopa.oPosZ,function (obj)
                    obj.oKoopaAgility = koopa.oKoopaAgility
                    obj.oKoopaTheQuickRaceIndex = koopa.oKoopaTheQuickRaceIndex
                    obj.oSubAction = KOOPA_THE_QUICK_ACT_UNUSED1
                    obj.oSubAction = koopa.oSubAction
                    obj.oFaceAnglePitch = koopa.oFaceAnglePitch
                    obj.oFaceAngleYaw = koopa.oFaceAngleYaw
                    obj.areaTimer = koopa.areaTimer
                    obj.areaTimerDuration = koopa.areaTimerDuration
                    obj.parentObj = koopahomeparent
                end)
                
            end
        end
    end
end

-- hook that is called once per frame
local function hook_update()
    local m = gMarioStates[0]
    if (gPlayerSyncTable[0].koopareset) then
        local koopa = obj_get_nearest_object_with_behavior_id(m.marioObj,id_bhvKoopa)
        if (koopa ~= nil) and (koopa.oKoopaMovementType < KOOPA_BP_KOOPA_THE_QUICK_BASE) then ---if obj_get_nearest_object_with_behavior_id got the wrong koopa
            while (koopa ~= nil) and (koopa.oKoopaMovementType < KOOPA_BP_KOOPA_THE_QUICK_BASE) do
                koopa = obj_get_next_with_same_behavior_id(koopa)
            end
        end
        kooparacerestart(koopa)
        gPlayerSyncTable[0].koopareset = false
    end
end

-- Called when the level is initialized
local function on_level_init()
    gPlayerSyncTable[0].koopareset = false
end

hook_event(HOOK_ON_DIALOG,on_dialog)--Called when a dialog appears. Return false to prevent it from appearing. Return a second parameter as any string to override the text in the textbox
hook_event(HOOK_UPDATE,hook_update) -- hook that is called once per frame	
hook_event(HOOK_ON_LEVEL_INIT, on_level_init) -- Called when the level is initialized

id_bhvkoopahome = hook_behavior(nil, OBJ_LIST_LEVEL, true, koopahome_init, koopahome_loop) --behavior id of the koopa home
id_bhvkoopahomeparent = hook_behavior(nil, OBJ_LIST_LEVEL, true, koopahome_init, koopahome_loop) --behavior id of the koopa home parent